
require 'simplecov'
SimpleCov.start

require 'raptor-io'

# This file was generated by the `rspec --init` command. Conventionally, all
# specs live under a `spec` directory, which RSpec adds to the `$LOAD_PATH`.
# Require this file using `require "spec_helper"` to ensure that it is only
# loaded once.
#

# Requires supporting ruby files with custom matchers and macros, etc,
# in spec/support/ and its subdirectories.
Dir["#{File.dirname(__FILE__)}/support/**/*.rb"].each do |f|
  next if f.include? '/webservers/'
  require f
end

# See http://rubydoc.info/gems/rspec-core/RSpec/Core/Configuration
RSpec.configure do |config|
  config.treat_symbols_as_metadata_keys_with_true_values = true
  config.run_all_when_everything_filtered = true
  config.filter_run :focus

  # Run specs in random order to surface order dependencies. If you find an
  # order dependency and want to debug it, you can fix the order by providing
  # the seed, which is printed after each run.
  #     --seed 1234
  config.order = 'random'

  config.before( :all ) do
    RaptorIO::Protocol::HTTP::Client.reset
    RaptorIO::Protocol::HTTP::Request::Manipulators.reset
    WebServers.killall
  end

  config.after( :all ) do
    RaptorIO::Protocol::HTTP::Client.reset
    RaptorIO::Protocol::HTTP::Request::Manipulators.reset
  end

  config.after( :suite ) do
    RaptorIO::Protocol::HTTP::Client.reset
    RaptorIO::Protocol::HTTP::Request::Manipulators.reset
    WebServers.killall
  end

end

EXAMPLE_PORT = 12345

def example_addr; '127.0.0.1'; end
def example_port; EXAMPLE_PORT; end
def example_ssl_port; EXAMPLE_PORT + 1; end

